{$M 1024,0,0}
{$S-,F-,I-,A-,V-,X+,T-}

uses
  _WriteS,Sounds,ComInt2F;

const
  ProcessName : string[8] = 'KBDCLICK';
  ProcessVersion = $020A;
  CopyrightName : string[16] = 'Keyboard Clicker';
  PrjStart : word = 1994;
  PrjEnd   : word = 1994;
  Producer : string[4] = 'SVsw';

var
  SaveInt09h  : pointer;

{$F+}
procedure NewInt09h; interrupt;
begin
  if Port[$60] < $80 then begin
    SoundOn(5000);
    DelayMs(1);
    SoundOff;
  end;
  asm
    pushf
    call SaveInt09h
  end;
end;
{$F-}

procedure ResetInts; far;
begin
  ResetIntVec($09,@NewInt09h,SaveInt09h);
end;

procedure RestoreInts; far;
begin
  RestoreIntVec($09,SaveInt09h);
end;

function SelfInts : boolean; far;
begin
 SelfInts := SelfIntVec($09,@NewInt09h);
end;

{$F+}
procedure ComProc(StackTop : word); interrupt;
var
  R : TIntRegisters absolute StackTop;
begin
  with R do case AL of
    $04 : AL := Byte(ReleaseProcess);
  end;
end;
{$F-}

var
  R : TCpuRegisters;

procedure Abort(Msg : string);
begin
  _Writeln(#$0D#$0A+Msg);
  Halt;
end;

var
  IPR : TInitProcessBlock;

begin
  RequiredDosVersion(3,30);
  _Writeln(Copyright(CopyrightName,
                     ProcessVersion,
                     PrjStart,
                     PrjEnd,
                     Producer
                    )
          );
  IPR := InitProcessBlock(ProcessName,
                          ProcessVersion,
                          @ComProc,
                          @ResetInts,
                          @RestoreInts,
                          @SelfInts
                         );
  case IPR of
    ipbIncorrectDosVersion : Abort('Incorrect DOS version.');
    ipbMultiplexorsBusy    : Abort('All multiplexors are busy.');
    ipbHandlersBusy        : Abort('All handlers are busy.');
    ipbOk :
      begin
        _Writeln(#$0D#$0A'Resident copy not found. Trying to install...');
        InstallProcess(ParagraphsToKeep,True);
        _Writeln('Install failure.');
      end;
    ipbAlreadyInstalled, ipbOtherVersionInstalled :
      begin
        _WriteNL;
        case IPR of
          ipbOtherVersionInstalled :
            _Write('Other version of '+ProcessName+' already installed.');
          ipbAlreadyInstalled :
            _Write(ProcessName + ' already installed.');
        end;
        _Write(' Trying to release...');
        R.AL := 4;
        CallProcess(ProcessBlockByName(ProcessName),R);
        if Boolean(R.AL) then
          Abort(ProcessName + ' has been released.')
        else
          Abort('Release failure.');
      end;
  end;
end.