unit Sounds;

interface

procedure SoundOn(Fr: Word);
procedure SoundOff;
procedure DelayMs(Ms: Word);
procedure ResetDelayCount;
procedure Beep;
procedure Sirena;
procedure SBell;
procedure LBell;
procedure Click;
procedure Crash;

implementation

uses
  Objects;

const
  DelayCount : word = 0;

procedure SoundOn(Fr: Word);
var
  S: Byte;
begin
  if Fr = 0 then Exit;
  Fr := LongDiv($1234DD, Fr);
  S := Port[$61];
  if S and 3 = 0 then begin
    Port[$61] := S or 3;
    Port[$43] := $B6;
  end;
  Port[$42] := Lo(Fr);
  Port[$42] := Hi(Fr);
end;

procedure SoundOff;
begin
  Port[$61] := Port[$61] and $FC;
end;

procedure MsLoop; near; assembler;
asm
@@1:
  sub    ax, 1
  sbb    dx, 0
  jc     @@2
  cmp    bl, es:[di]
  je     @@1
@@2:
end;

procedure DelayMs(Ms: Word); assembler;
asm
  mov    cx, Ms
  jcxz   @@2
  mov    di, Seg0040
  mov    es, di
  xor    di, di
  mov    bl, es:[di]
@@1:
  mov    ax, DelayCount;
  or     ax, ax
  jz     @@2
  xor    dx, dx
  call   MsLoop
  loop   @@1
@@2:
end;

procedure ResetDelayCount; assembler;
asm
  mov    ax, Seg0040
  mov    es, ax
  mov    di, $6C
  mov    bl, es:[di]
@@1:
  cmp    bl, es:[di]
  je     @@1
  mov    bl, es:[di]
  mov    ax, -28
  cwd
  call   MsLoop
  not    ax
  not    dx
  mov    bx, 55
  div    bx
  mov    DelayCount, ax
end;

procedure Beep;
begin
  SoundOn(880);
  Delayms(50);
  SoundOn(440);
  Delayms(20);
  SoundOn(660);
  Delayms(50);
  SoundOff;
end;

procedure Sirena;
var
  i : word;
begin
  for i:=450 to 2100 do begin
    SoundOn(i);
    DelayMs(1);
  end;
  for i:=2100 downto 450 do begin
    SoundOn(i);
    DelayMs(1);
  end;
  SoundOff;
end;

procedure SBell;
begin
  SoundOn(1000);
  DelayMs(50);
  SoundOff;
end;

procedure Click;
begin
  SoundOn(5000);
  DelayMs(1);
  SoundOff;
end;

procedure LBell;
begin
  SoundOn(1000);
  DelayMs(150);
  SoundOff;
end;

procedure Crash;
var
  i : word;
begin
  Randomize;
  for i := 1 to 1500 do begin
    SoundOn(Random(600) + 40);
    DelayMs(1);
  end;
  SoundOff;
end;

begin
  ResetDelayCount;
end.